typedef struct
{
	uint8_t type_trans; //   (,  , )
	uint8_t flag_end_device; //  - . 
	uint8_t f_title_is; //  -  
	uint8_t f_6_byte_rec; // 6      
	uint8_t f_head_ready; //  -   
	uint8_t f_del_pack; //     
	uint8_t f_trans_go;
	uint8_t f_error_SMS;
	uint8_t f_add_save_head; //    . .,     
	uint8_t f_end_device_rec;
	uint8_t out_port_TOR_first_pack; 
	uint8_t in_port_TOR_first_pack;	
	uint8_t f_port_direct;
	uint8_t contr_who_busy;
	uint8_t port_who_busy;
	uint8_t f_end_port_busy;
	uint8_t f_add_standart_head;
	uint16_t test;
	
	uint8_t f_end_port_busy_t;
	uint8_t f_add_save_head_t;
	uint8_t f_end_device_rec_t;
	
	uint8_t f_time_rec_pack_ready;
	uint8_t f_time_4_pack_ready;
	
} kernel_port_init;

typedef struct
{
	uint8_t f_need_crypt;
	uint8_t f_crypt_done;
	uint8_t f_need_decript;
	uint8_t f_decropt_done;
} crypt_data_init;

typedef struct
{
	uint16_t N_byte_rec; //      
	uint16_t buf_one_rec_byte; //            
	uint16_t work_buf_rec;	//         
	uint8_t work_byte_in_work_buf_rec; //      
	uint16_t N_byte_in_this_pack[8]; 
	uint8_t number_pack_in_this_port;
	
} table_port_init;

typedef struct 
{
	uint16_t time_rec;
	uint16_t time_1;
	uint16_t time_2;
	uint16_t time_3;
	uint16_t time_4;
	uint16_t time_last_byte_rec;
	uint32_t time_last_byte_rec_NTSTR;
	uint16_t time_last_trans;
	uint32_t time_last_trans_NTSTR;
	uint8_t f_analiz_time_rec;
	uint8_t f_time_3_repletion;
	uint8_t f_time_2_repletion;
	uint8_t f_time_rec;
	uint8_t f_time_1;
	uint8_t f_time_2;
	uint8_t f_time_3;
	uint8_t f_time_4;
	uint32_t time_3_NTSTR;
	uint32_t time_2_NTSTR;
	
} time_port_init;

typedef struct
{
	uint8_t test_buf[6];
	uint8_t number_byte_in_test_buf;
	uint8_t f_test_buf_full;
	
} test_buf_port_init;

/*  - 256 32-  */
typedef struct
{
	uint8_t buf_byte[32];

} buf_init;


/* - */
typedef struct
{
	//  6 
	uint32_t title_4_byte;
	uint16_t title_2_byte;
	//  : 1  - , 1  - 
	uint8_t in_contr;
	uint8_t in_port;
	// : 1  - , 1  - 
	uint8_t out_contr;
	uint8_t out_port;
	//  2 
	uint16_t command;
	// ID  2  
	uint16_t ID;
	//   2 
	uint16_t N_pack;
	//     2 
	uint16_t N_byte_in_pack;
	//     2 
	uint16_t N_byte_in_SM; // SM - smart message
	//   10 
	uint16_t t1;
	uint16_t t2;
	uint16_t t3;
	uint16_t t4;
	uint16_t t5;
	//    2 
	uint16_t crc;
	
} head_pack_init;


//  -  
typedef struct
{
	uint8_t in_port; //    
	uint8_t in_port_TOR; //     
	uint8_t out_port; //    
	uint8_t out_port_TOR; //     
	uint16_t N_byte_rec; //   
	uint16_t N_byte_pack_out; //     
	uint16_t num_one_buf; //     
	uint16_t N_pack;
	uint8_t in_contr;
	uint8_t f_time_4_end; //    
	uint8_t f_time_rec_end;
	uint8_t f_str_ready_trans; //      
	uint8_t f_str_busy; //   
	uint8_t f_time_rec_pack_end;
	uint8_t f_time_4_pack_end;
	
} table_trans_m_init;

typedef struct
{
	uint8_t f_end_dev;
	uint8_t f_do_str;
	uint8_t f_err;
	uint8_t f_save_head;
	uint8_t f_time_1;
	uint8_t type_trans;
	uint16_t time_1;
	uint32_t time_1_NTSTR;
	uint8_t f_time_1_repletion;
	uint16_t time_2;
	uint16_t time_3;
	uint16_t time_4;
	uint16_t time_pack; //    
	uint32_t time_pack_NTSTR;
	
	
} table_trans_l_init;


//  -   
typedef struct
{
	uint8_t contr[8]; // contr[ ] =  
	
} table_of_route_init;

/* : _-  */
typedef struct 
{
	uint8_t buf[N_BYTE_DRIVER_BUF]; //   
	uint8_t N_byte_start; //  
	uint8_t N_byte_end; //  
	uint16_t N_byte_trans_full; // -   
	uint16_t first_buf_trans; //     
	uint16_t N_byte_trans;
	uint8_t f_port_busy_rec;
	
} driver_port_init;


typedef struct
{
	uint8_t port_end_dev;
	uint16_t adr_buf_save_head;
	uint8_t f_end;
	
} table_end_dev_init;
