#include "temporary.h"

void usart_trans_1_byte_1_port(void)
{
	uint16_t save_buf;
	
	if(driver_port[1].N_byte_trans_full != 0)
	{
		driver_port[1].N_byte_trans_full--;
	
		//       (N_byte_trans_full == 0)
		if((driver_port[1].N_byte_trans_full) != 0)
		{			
			//      32.  
			//         
			driver_port[1].N_byte_trans++;
			
			//   32- 
			if(driver_port[1].N_byte_trans == 32)
			{
				//  
				reverse_f_busy_buf(driver_port[1].first_buf_trans);
				
				//   ,   . 
				//  ,     300
				save_buf = driver_port[1].first_buf_trans;
				driver_port[1].first_buf_trans = next_buf_for_buf[driver_port[1].first_buf_trans];
				next_buf_for_buf[save_buf] = 300;
				
				//     32. 
				driver_port[1].N_byte_trans = 0;
			}
			
			//   usart  
			USART_SendData(USART1, buf[driver_port[1].first_buf_trans].buf_byte[driver_port[1].N_byte_trans]);	
		}
		
		//   
		else
		{
			//   ,    -  
			driver_port[1].N_byte_trans_full = 0;
			driver_port[1].N_byte_trans = 0;
			
			//  
			reverse_f_busy_buf(driver_port[1].first_buf_trans);
			
			//   ,   . 
			//  ,     300
			save_buf = driver_port[1].first_buf_trans;
			driver_port[1].first_buf_trans = next_buf_for_buf[driver_port[1].first_buf_trans];
			next_buf_for_buf[save_buf] = 300;
			
			if(kernel_port[1].f_trans_go == 1
				 && driver_port[1].N_byte_trans_full == 0 
				 && kernel_port[1].f_port_direct == 0)
			{
				kernel_port[1].f_trans_go = 0;
				time_port[1].f_time_3 = 0;
			}
			
		}
	}	
}


void usart_trans_1_byte_2_port(void)
{
	uint16_t save_buf;
	
	if(driver_port[2].N_byte_trans_full != 0)
	{
		driver_port[2].N_byte_trans_full--;
	
		//       (N_byte_trans_full == 0)
		if((driver_port[2].N_byte_trans_full) != 0)
		{			
			//      32.  
			//         
			driver_port[2].N_byte_trans++;
			
			//   32- 
			if(driver_port[2].N_byte_trans == 32)
			{
				//  
				reverse_f_busy_buf(driver_port[2].first_buf_trans);
				
				//   ,   . 
				//  ,     300
				save_buf = driver_port[2].first_buf_trans;
				driver_port[2].first_buf_trans = next_buf_for_buf[driver_port[2].first_buf_trans];
				next_buf_for_buf[save_buf] = 300;
				
				//     32. 
				driver_port[2].N_byte_trans = 0;
			}
			
			//   usart  
			USART_SendData(USART2, buf[driver_port[2].first_buf_trans].buf_byte[driver_port[2].N_byte_trans]);	
		}
		
		//   
		else
		{
			//   ,    -  
			driver_port[2].N_byte_trans_full = 0;
			driver_port[2].N_byte_trans = 0;
			
			//  
			reverse_f_busy_buf(driver_port[2].first_buf_trans);
			
			//   ,   . 
			//  ,     300
			save_buf = driver_port[2].first_buf_trans;
			driver_port[2].first_buf_trans = next_buf_for_buf[driver_port[2].first_buf_trans];
			next_buf_for_buf[save_buf] = 300;
			
			if(kernel_port[2].f_trans_go == 1
				 && driver_port[2].N_byte_trans_full == 0 
				 && kernel_port[2].f_port_direct == 0)
			{
				kernel_port[2].f_trans_go = 0;
				time_port[2].f_time_3 = 0;
			}
		}
	}	
}


void usart_trans_1_byte_3_port(void)
{
	uint16_t save_buf;
	
	if(driver_port[3].N_byte_trans_full != 0)
	{
		driver_port[3].N_byte_trans_full--;
	
		//       (N_byte_trans_full == 0)
		if((driver_port[3].N_byte_trans_full) != 0)
		{			
			//      32.  
			//         
			driver_port[3].N_byte_trans++;
			
			//   32- 
			if(driver_port[3].N_byte_trans == 32)
			{
				//  
				reverse_f_busy_buf(driver_port[3].first_buf_trans);
				
				//   ,   . 
				//  ,     300
				save_buf = driver_port[3].first_buf_trans;
				driver_port[3].first_buf_trans = next_buf_for_buf[driver_port[3].first_buf_trans];
				next_buf_for_buf[save_buf] = 300;
				
				//     32. 
				driver_port[3].N_byte_trans = 0;
			}
			
			//   usart  
			USART_SendData(USART3, buf[driver_port[3].first_buf_trans].buf_byte[driver_port[3].N_byte_trans]);	
		}
		
		//   
		else
		{
			//   ,    -  
			driver_port[3].N_byte_trans_full = 0;
			driver_port[3].N_byte_trans = 0;
			
			//  
			reverse_f_busy_buf(driver_port[3].first_buf_trans);
			
			//   ,   . 
			//  ,     300
			save_buf = driver_port[3].first_buf_trans;
			driver_port[3].first_buf_trans = next_buf_for_buf[driver_port[3].first_buf_trans];
			next_buf_for_buf[save_buf] = 300;
			
			if(kernel_port[3].f_trans_go == 1
				 && driver_port[3].N_byte_trans_full == 0 
				 && kernel_port[3].f_port_direct == 0)
			{
				kernel_port[3].f_trans_go = 0;
				time_port[3].f_time_3 = 0;
			}
			
		}
	}	
}
