typedef unsigned char uint8_t;

void set_RS(void);
void clear_RS(void);
void set_RW(void);
void clear_RW(void);
void set_E(void);
void clear_E(void);
void set_DB0(void);
void clear_DB0(void);
void set_DB1(void);
void clear_DB1(void);
void set_DB2(void);
void clear_DB2(void);
void set_DB3(void);
void clear_DB3(void);
void set_DB4(void);
void clear_DB4(void);
void set_DB5(void);
void clear_DB5(void);
void set_DB6(void);
void clear_DB6(void);
void set_DB7(void);
void clear_DB7(void);

void blink_E(void);

void hd44780_init(void);
void send_DB_0_7_lines(uint8_t command);
void hd44780_write(char ldata[]);
void hd44780_command(uint8_t lcdcmnd);
void hd44780_char(uint8_t ldata);
void hd44780_goto(uint8_t x, uint8_t y);

void hd44780_init_4_bit(void);
void send_DB_4_7_lines(uint8_t command);
void hd44780_write_4_bit(char ldata[]);
void hd44780_command_4_bit(uint8_t lcdcmnd);
void hd44780_char_4_bit(uint8_t ldata);
void hd44780_goto_4_bit(uint8_t x, uint8_t y);

